=== debian/changelog ===
openj9-18 (0.33.1-1) unstable; urgency=medium

  * Rebuild with new package names

 -- Mathieu Baudier <mbaudier@argeo.org>  Wed, 05 Nov 2025 16:58:08 +0000
